/* For free support for VSIDE, please visit www.vsdsp-forum.com */

// Starting point template for creating VSOS applications.
// This will create a <projectname>.DL3 file, which you can copy to 
// your VS1005 Developer Board's system disk's SYS subdirectory.

// DL3 files require VSOS kernel version 0.3x to run.

// If you add the libary name to S:CONFIG.TXT, it will be loaded
// and run during boot-up. 

#include <vo_stdio.h>
#include <volink.h>     // Linker directives like DLLENTRY
#include <apploader.h>  // RunLibraryFunction etc
#include <timers.h>
#include <libaudiodec.h>


void *decoderLibrary = NULL;


ioresult PlayFile(FILE *fp) {
	AUDIO_DECODER *audioDecoder = NULL;
	char *errorString = "";
	int eCode = 0;

	audioDecoder = CreateAudioDecoder(decoderLibrary, fp, stdaudioout, NULL, auDecFGuess);
	if (!audioDecoder) {
		printf("Couldn't create audio decoder\n");
		return S_ERROR;
	}

	eCode = DecodeAudio(decoderLibrary, audioDecoder, &errorString);
	
	printf("\nDecode finished, ");
	printf("errorCode %d, errortext %s\n", eCode, errorString);

	DeleteAudioDecoder(decoderLibrary, audioDecoder);
	return S_OK;
}


int main(char *filespec) {
	FILE *fp = NULL;
	int filenum = 0;

	kernelDebugLevel = 99; //get lots of kernel debug output to stderr (UART)
	printf("PlayFiles %s\n",filespec);


	decoderLibrary = LoadLibrary("audiodec");
	if (!decoderLibrary) {
		return S_ERROR;
	}

	while(1) {
		static char fnumMode[10];
		printf("Open file %d...\n",filenum+1);

		sprintf(fnumMode,"rb#%d",filenum);
		fp = fopen(filespec,fnumMode); // e.g. fopen("N:MUSIC\*","rb#123");
		if (fp) {
			printf("Playing %s ",fp->Identify(fp,NULL,0)); //this Identify is good to be right after the fopen
			printf("from device %s...\n",fp->dev->Identify(fp->dev,NULL,0));
			
			PlayFile(fp);
			fclose(fp);
			filenum++;
		} else {
			//filenum=0; //Restart from first file
			break; //end of files, end playing
		}
	}

	DropLibrary(decoderLibrary);
	return S_OK; //End of files, ok exit
}
