/// \file main.c VSOS3 Audio Device Driver with input/output (AUDIO.DL3)
/// \author Henrik Herranen, VLSI Solution Oy
// For further instructions on how to use the audio driver can be found
// in the VS1005 VSOS Programmer's Guide, available at
// http://www.vlsi.fi/en/support/software/vside.html

/* For free support for VSIDE, please visit www.vsdsp-forum.com */

// Starting point template for creating VSOS3 libraries and device drivers.
// This will create a <projectname>.DL3 file, which you can copy to 
// your VS1005 Developer Board's system disk's SYS subdirectory.

// DL3 files require VSOS3 kernel version 0.3x to run.


// If you add the libary name to S:CONFIG.TXT, and put the library 
// to S:SYS, it will be loaded and run during boot-up. 

/*
  NOTE!
  This driver is specific to VS1005g because it uses ROM symbols
  clockSpeed, AudioBufFree, and hwSampleRate.
 */
#include <vo_stdio.h>
#include <volink.h>     // Linker directives like DLLENTRY
#include <apploader.h>  // RunLibraryFunction etc
#include <devAudio.h>
#include <audiofs.h>
#include <timers.h>

FILE *stdaudioin_orig = 0;
FILE *stdaudioout_orig = 0;
DEVICE audioDevice;

DLLENTRY(init)
ioresult init(char *paramStr) {
	stdaudioin_orig = stdaudioin;
	stdaudioout_orig = stdaudioout;
	DevAudioCreate(&audioDevice, NULL, 0);
	vo_pdevices['A'-'A'] = &audioDevice;
	stdaudioout = stdaudioin = fopen("A:of=48000","r+"); //default input buffer size is 512 stereo samples
	ioctl(stdaudioout, IOCTL_AUDIO_SET_OUTPUTS, (void*)(AOR_DAC | AOR_I2S | AOR_SPDIF));
	return S_OK;
}


DLLENTRY(fini)
void fini(void) {
	// Add code here to force release of resources such as 
	// memory allocated with malloc, entry points, 
	// hardware locks or interrupt handler vectors.
	stdaudioin = stdaudioin_orig;
	stdaudioout = stdaudioout_orig;
}
